/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */
//
//	File		share.h
//	Purpose		defs which are shared between VxD and host
//
//	Created by 	S. Gillies
//	Copyright	(c) 1998 VLSI Vision Ltd, all rights reserved.
//
//	Revision history
//		1-26	27-02-97	SG	1-08 Host, API_VER 4
//
                                     
#ifndef __API_PUB_H__                                     
#define __API_PUB_H__                                     

#define API_VER	4

#define VER_ALLOC_DMA_BUFFER	2
#define VER_FREE_DMA_BUFFER     1
#define VER_GET_RESOURCES       2
#define VER_PCI_CONFIG			3
#define VER_PCI_CONFIG_PNP		4

enum {
	VVLCPIA_VXD_API_GET_VERSION,
	VVLCPIA_VXD_API_ALLOC_BUFFER,	
	VVLCPIA_VXD_API_FREE_BUFFER,
	VVLCPIA_VXD_API_GET_RESOURCES,
	VVLCPIA_VXD_API_READ_PCI_REG,
	VVLCPIA_VXD_API_WRITE_PCI_REG,
	VVLCPIA_VXD_API_GETPCICFG,
	VVLCPIA_VXD_API_SETPCICFG
};

//	Data is passed back to the host via these structures, so the host must have
//	identical definitions and use the same structure member alignment.

#pragma pack( 1 )	//	ensure structure packing is compatible with vxd
typedef struct {
	WORD bufferSize;
	DWORD bufferPhys;		//buffer physical address
	DWORD bufferLinearAddress;	//GDT selector for ring 3
} DMA_BUFFER_INFO, *PDMA_BUFFER_INFO;

typedef struct {
	BYTE lptNo;
	WORD IOaddr;
	BYTE irqNo;
	BYTE dmaCh;
	BYTE ECP;
	char deviceDesc[40];
} CPIA_RESOURCE_INFO, *PCPIA_RESOURCE_INFO;

typedef struct {
	BYTE bus;
	BYTE device;
	BYTE function;
	BYTE reg;
	DWORD value;
} PCI_CONFIG_REG, *PPCI_CONFIG_REG;

typedef struct {
	WORD vendorId;
	WORD deviceId;
	BYTE reg;
	BYTE value;
} PCI_CONFIG_INFO, *PPCI_CONFIG_INFO;
#pragma pack( )	//	restore default structure packing

#endif //__API_PUB_H__
