/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */


#define CV_FRAME_HEADER_LEN	64

#define CV_HEADER0          0
#define CV_HEADER1          1

#define CV_TIMESTAMP_D0     2		/* D0:7 of time stamp 								*/
#define CV_TIMESTAMP_D8     3		/* D8:15 of time stamp 								*/
#define CV_UNUSED			4		/* this added so that we can't get 0xFFFF in header */
#define CV_TIMESTAMP_D16    6		/* D16:23 of time stamp 	 						*/
#define CV_TIMESTAMP_D24    7		/* D24:31 of time stamp 	 						*/

#define CV_VPSTATUS   		8	
#define CV_CAM_STATUS		9
#define CV_EXP_ACC		   10		
#define CV_GAIN			   11
#define CV_COARSE_LO	   12
#define CV_COARSE_HI	   13
/*
.
. other VP Stuff here
.
*/

/* CAPTURE Module stuff */
#define CV_VIDEO_SIZE       16
#define CV_SUB_SAMPLE       17
#define CV_YUV_ORDER        18

#define CV_COL_START        24
#define CV_COL_END          25
#define CV_ROW_START        26
#define CV_ROW_END          27

#define CV_COMP_ENABLE		28
#define CV_DECIMATION       29
#define CV_Y_THRESH         30
#define CV_UV_THRESH        31

/* the eight fields below are a copy of the gStatus structure */
#define CV_SYSTEM_STATE     32
#define CV_GRAB_STATE       33
#define CV_STREAM_STATE     34
#define CV_FATAL_ERROR      35
#define CV_CMD_ERROR        36
#define CV_DEBUG_FLAGS      37
#define CV_VP_STATUS        38
#define CV_ERROR_CODE	   	39

#define CV_CR_ACHIEVED		40
#define CV_FR_ACHIEVED		41




/* these are the value of the two magic numbers at the start 	*/
/* of the frameheader											*/  
#define CV_HEADER_0_MAGIC   0x19
#define CV_HEADER_1_MAGIC   0x68   



#define CV_EOL_CODE			0xFD
#define CV_EOF_CODE			0xFF



           


