/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */
/* possible states returned by CLINK_GetUploadStatus()			*/
/* ... and passed to UploadStatusCallback()						*/
#define UPLOAD_IDLE			0
#define UPLOAD_STARTING		1
#define UPLOAD_CHUNK_START	2
#define UPLOAD_CHUNK_END	3
#define UPLOAD_FINISHING	4
#define	UPLOAD_FAILED		5

 

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef DOS_APP
#define __export WINAPI
#define _export
#endif


BOOL  __export WINAPI CLINK_Init( void );
void  __export WINAPI CLINK_Fini( void );


/* following two functions will stall until the operation is complete	*/
BOOL  __export WINAPI CLINK_TransferMsg( PLINK pLink, BYTE Module, BYTE Proc, CMD_DATA *CmdData,
					    BOOL DataReadFlag, WORD DataBytes, DATA_BUFFER *DataBuffer );


BOOL  __export WINAPI CLINK_UploadStreamData( PLINK pLink, BOOL EndOnFF, DWORD MaxDataBytes, BYTE __huge *DataBuffer, 
							 DWORD *ActualBytes, DWORD StreamChunkSize );


/* functions to initiate and monitor concurrent operation of upload	 	*/
BOOL  __export WINAPI CLINK_StartUpload( PLINK pLink, BOOL UseStreamReadyINT, BOOL DoBackgroundUpload,
										 DWORD MaxDataBytes, BYTE __huge *DataBuffer, DWORD StreamChunkSize,
										 BOOL EndOnFF );	

BOOL  __export WINAPI CLINK_AbortUpload( PLINK pLink );	/* aborts upload - sets state to UPLOAD_NOT_READY */ 

BOOL  __export WINAPI CLINK_GetUploadStatus( PLINK pLink, BYTE *Status, DWORD *ActualBytes );	


/* function to setup the UploadStatus callback function 		*/
/*  - call with NULL ptr to disable callback					*/
// BOOL CLINK_InstallUploadStatusCallback( PLINK pLink, CALLBACK_FUNC *Func() );

/* below called whenever there is a change in status of the upload stream */
// CALLBACK_FUNC UploadStatusCallback( PLINK pLink, UPLOAD_STATUS Status, DWORD ActualBytes );


/* functions to cater for the PP StreamReady Interrupt	*/
// BOOL CLINK_InstallStreamReadyCallback( PLINK pLink, CALLBACK_FUNC *Func() );

// CALLBACK_FUNC StreamReadyCallback( PLINK pLink, void );


/* functions to set/get timeout used in case upload fails  	*/
BOOL  __export WINAPI CLINK_SetUploadTimeout( PLINK pLink, WORD Timeout_ms );   
BOOL  __export WINAPI CLINK_GetUploadTimeout( PLINK pLink, WORD *Timeout_ms );


/* functions to set/get timeout used in case PP StreamReady Interrupt fails 			*/ 
/* can also be used to implement the callback function required by the VSTREAM module 	*/
BOOL  __export WINAPI CLINK_SetStreamReadyTimeout( PLINK pLink, WORD Timeout_ms );
BOOL  __export WINAPI CLINK_GetStreamReadyTimeout( PLINK pLink, WORD *Timeout_ms );


#ifdef __cplusplus
}
#endif




