/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */
// DEVLOAD.H - include file for VxD loader/unloader utility functions
// Copyright (c) 1995, Vireo Software, Inc.

#define VXDLDR_DEVICE_ID 0x27

// Define error returns from VXDLDR

#define  VXDLDR_ERR_OUT_OF_MEMORY   	1
#define  VXDLDR_ERR_IN_DOS    		2
#define  VXDLDR_ERR_FILE_OPEN_ERROR 	3
#define  VXDLDR_ERR_FILE_READ    	4
#define  VXDLDR_ERR_DUPLICATE_DEVICE   	5
#define  VXDLDR_ERR_BAD_DEVICE_FILE 	6
#define  VXDLDR_ERR_DEVICE_REFUSED  	7
#define  VXDLDR_ERR_NO_SUCH_DEVICE  	8
#define  VXDLDR_ERR_DEVICE_UNLOADABLE  	9
#define  VXDLDR_ERR_ALLOC_V86_AREA  	10
#define  VXDLDR_ERR_BAD_API_FUNCTION   	11

#define	 VXDLDR_ERR_NOT_LOADED		-1
#define  VXDLDR_ERR_MAX       		11

// Define commands (AX value) for VXDLDR calls

#define CMD_LOAD 	1
#define CMD_UNLOAD	2

// Prototypes for functions in devload.cpp

#ifdef __cplusplus
extern "C"
{         
#endif

int	LoadVxD(const char* vxdname);
int	UnloadVxD(const char* vxdname);
BOOL	MakeSureVXDLDRIsPresent();
const 	char* 	GetVXDLDRStatusString(int status);
int 	(far *LocateVxD(WORD devID))();

#ifdef __cplusplus
}
#endif

                                
