/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */
#ifndef CAMTYPES
#define CAMTYPES
  

#define     SWORD   int

#define     TRUE    1
#define     FALSE   0

/* two time functions actually defined in dvm_msg.h -- for no very good reason */
#ifndef CLOCKS_PER_SEC 
#define CLOCKS_PER_SEC  1000UL
#endif


/*DWORD GetTime();*/
void Delay( WORD wMSecs );

#endif

/*
    debug macro definations 
*/
#define BPT(str)    MessageBox(NULL,str,VER,MB_OK|MB_ICONEXCLAMATION|MB_SYSTEMMODAL)

#ifdef _DEBUG

/*
#define D1(sz)      (OutputDebugString("\r\nvvlcap: "),OutputDebugString(sz))
#define D(sz)       (OutputDebugString(sz))
*/

/* These lines are used to capture debug output from 32 bit apps */

#define D1(sz)      (OutputDebugStr("\r\nvvlcap: "),OutputDebugStr(sz))
#define D(sz)       (OutputDebugStr(sz))

#else

#define D1( dummy )
#define D( dummy )  

#endif


/*
    Image types and sizes
*/                
#define     CIF_COLS        352L
#define     CIF_ROWS        288L

#define     QCIF_COLS       (CIF_COLS/2)
#define     QCIF_ROWS       (CIF_ROWS/2)


#define     SIF_COLS        320L
#define     SIF_ROWS        240L


#define     QSIF_COLS   (SIF_COLS/2)
#define     QSIF_ROWS   (SIF_ROWS/2)


/* compression settings */
typedef enum {
              CMP_OFF,
              CMP_AUTOMATIC,
              CMP_MANUAL
             } COMP_MODE;


#define VID_CONFERENCE	0
#define VID_CAPTURE		1


typedef enum { PWR_UNINITIALISED,
               PWR_PASSTHROUGH, 
               PWR_LOW,
               PWR_HI,
               PWR_SUSPEND
             } POWER_MODE;

typedef enum { CB_IGNORE,    /* don't change current setting */ 
               CB_MANUAL, 
               CB_AUTOMATIC, 
               CB_DISABLE 
             } COL_BALANCE;
             
typedef enum { FPS_UNKNOWN, 
               FPS_30, 
               FPS_25, 
               FPS_15, 
               FPS_125, 
               FPS_75
             } FRAMERATE;
             
typedef enum { MAINS_50HZ, 
               MAINS_60HZ
             } MAINS_FREQ;
             
typedef enum { EXP_IGNORE,    /* don't change current setting */
               EXP_MANUAL, 
               EXP_AUTOMATIC, 
               EXP_AUTODISABLE
             } EXPOSURE;

/* centreweighting of the image when calculating exposure */
typedef enum { CW_IGNORE,    /* don't change current setting */
               CW_WEIGHT,
               CW_FLAT
             } CWEIGHT;         
             
typedef enum { FLK_DISABLED,   /* no flicker correction requested */
               FLK_OFF,        /* flicker correction has switched off */
               FLK_ON,         /* flicker correction is on */
               FLK_RESTART     /* flicker control has been restarted */
             } FLK_STATE;
  


#ifndef COMPAT_PORT_TYPE
#define NULL_PORT_TYPE		0x00	
#define COMPAT_PORT_TYPE 	0x01		
#define BIDIR_PORT_TYPE		0x02
#define ECP_PORT_TYPE		0x04
#define EPP_PORT_TYPE		0x08
#define DMA_PORT_TYPE		0x10	/* ECP DMA transfers can be used 		*/
#define INT_PORT_TYPE		0x20	/* PP interrupt can be used 			*/
#define FAST_DMA_PORT_TYPE 	0x40	/* Fast DMA transfers can be used 		*/
#endif

#ifndef DBG_NOCAMERA
#define DBG_NOCAMERA     0x0001  /* camera not detected on startup */
#define DBG_INITPPC      0x0004  /* display errors during ppc initialisation */

#define DBG_DISABLE_DMA  0x0008  /* disable ECP DMA mode  */
#define DBG_DISABLE_ECP  0x0010  /* disable ECP ( force it to use 4 bit ) */
#define DBG_TRACEMSG     0x0020  /* message tracing. (tracemsg function) - kindof working */
#define DBG_DISABLE_FDMA 0x0040  /* disable Type F DMA transfers		 */
#endif


