/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */
/* CZOOM.H
   25/8/97
   class header file 
*/

#ifdef _WIN32
#define _near
#endif

/* get the data pointer for the window */                                    
#define CZ_PTR(h)   (LPCZOOM) GetWindowLong (h, 0)
                                    
#define STR_CZOOM   "czoom"

#define ST_NONE     0    /* mouse not pressed */
#define ST_MDOWN    1    /* button pressed */
#define ST_MUP      2    /* button released */
                                   
#define QCIF_WIDTH  176
#define QCIF_HEIGHT 144                                   
                                   
#define PAR_WIDTH   178  /* parent rectangle width (qcif) + 2 */
#define PAR_HEIGHT  146                                          

/* default inner rectangle sizes */
#define CLD_WIDTH   ((PAR_WIDTH - 2) / 2)     /* allow for parent border */
#define CLD_HEIGHT  ((PAR_HEIGHT - 2) / 2)      

/* macros to work out the child rectangle width and height */
#define IRECTWID(x) ((x). right - (x). left)
#define IRECTHT(x)  ((x). bottom - (x). top)

//#define ONEDGE(r)       ((r)->left == 1 || (r)->right == PAR_WIDTH - 1 || 
//                         (r)->top == 1  || (r)->bottom == PAR_HEIGHT - 1)
//#define ON_X_EDGE(r)    ((r)->left == 1 || (r)->right == PAR_WIDTH - 1)
//#define ON_Y_EDGE(r)    ((r)->top == 1  || (r)->bottom == PAR_HEIGHT - 1)

/* messages */

#define CZ_SETPOSITION  (WM_USER)        /* lparam = new top left of rect */
#define CZ_GETPOSITION  (WM_USER + 1)    /* returns top left of rectangle */
#define CZ_SETSIZE      (WM_USER + 2)    /* set size of inner rectangle */

#define CZN_BUTTONDOWN  (WM_USER + 20)   /* sent to parent when mouse clicked */
#define CZN_MOVED       (WM_USER + 21)   
#define CZN_BUTTONUP    (WM_USER + 22)   /* sent to parent when move stops */


typedef struct _tag_czoom {
    UINT state ;        /* mouse up/down etc */
    POINT mouseofs ;    /* offset of mouse from top left of rectangle */
    POINT parofs ;      /* offset of parent rectangle within window */
    POINT topleft ;     /* current top left of rectangle */
    RECT r ;            /* inner rectangle */
    HBRUSH hbr ;        /* used to draw rectangle when don't have focus */
    HBRUSH hback ;      /* window background - used to erase rectangle */
    HBRUSH hfocus ;     /* used to draw rectangle when do have focus */
    HBRUSH hctlcolour ; /* background colour to make it grey */
    HCURSOR hcur ;      /* cursor is changed while rectangle moves. This is
                           the cursor prior to the move */
   } CZOOM, _near *PCZOOM, *LPCZOOM ;
   

BOOL czInit (HINSTANCE hinst) ;
LRESULT CALLBACK _loadds czWndProc (HWND hwnd, UINT msg, WPARAM wparam, 
                                    LPARAM lparam) ;
   
