/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */

#include "common.h"
#include "drv_ver.h"
#include <ver.h>


extern HINSTANCE ghModule ;   /* dll instance handle. Declared in dvm_msg.c */


BOOL get_version(LPSTR buf, int maxlen)

{
	return get_version_data("FileVersion", buf, maxlen);
}


/*-----------------------------------------------------------------*/
/* extract the description of the driver from the version info resource */

BOOL get_driver_desc(LPSTR buf, int maxlen)

{
 return get_version_data("FileDescription", buf, maxlen);
}

/*-----------------------------------------------------------------*/

BOOL get_version_data(LPSTR verkey, LPSTR buf, int maxlen)

{
	PSTR pver ;                 
	LPSTR ptmp ;
	DWORD verhandle,
		numb ;
	char modname [_MAX_PATH],
		keybuf [_MAX_PATH] ;
	int res = FALSE ;           
	UINT tlen = 0 ;
	
	*buf = '\0' ;
	
	GetModuleFileName(ghModule, modname, sizeof(modname));
	numb = GetFileVersionInfoSize(modname, &verhandle);
	
	if ((pver =(PSTR) LocalAlloc(LPTR, numb)) != NULL)
	{                           
		if (GetFileVersionInfo(modname, verhandle, numb, pver))
		{                   
			wsprintf(keybuf, "\\StringFileInfo\\040904e4\\%s",(LPSTR) verkey);
			VerQueryValue(pver, keybuf, &ptmp, &tlen);
			if (tlen)
			{
				lstrcpy(buf, ptmp);
				res = TRUE ;
			}
		}
		
		LocalFree((HLOCAL) pver);
	}
	
	return res ;
}
