/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */
/* INFO_HDR.C
   18-07-97
   image size, bitmappy functions etc 
*/   

#include "common.h"


 
void BIH_Init( LPVOID Ptr ) {
    LPBITMAPINFOHEADER BIH;

    BIH = (LPBITMAPINFOHEADER)Ptr;

    BIH->biSize = sizeof(BITMAPINFOHEADER);
    BIH->biWidth = 0;
    BIH->biHeight = 0;
    BIH->biPlanes = 1;
    BIH->biBitCount = 0;
    BIH->biCompression = 0;
    BIH->biSizeImage = 0;
    BIH->biXPelsPerMeter = 2000;
    BIH->biYPelsPerMeter = 2000;
    BIH->biClrUsed = 0;
    BIH->biClrImportant = 0;

    return;
}


void BIH_SetType( LPVOID Ptr, WORD BitCount, DWORD Compression ) {
    LPBITMAPINFOHEADER BIH;

    BIH = (LPBITMAPINFOHEADER)Ptr;
    BIH->biBitCount = BitCount;
    BIH->biCompression = Compression;
    return;
}

void BIH_GetType( LPVOID Ptr, LPWORD BitCount, LPDWORD Compression ) {
    LPBITMAPINFOHEADER BIH;

    BIH = (LPBITMAPINFOHEADER)Ptr;
    *BitCount = BIH->biBitCount;
    *Compression = BIH->biCompression;
    return;
}


void BIH_SetImageSize( LPVOID Ptr, LONG Width, LONG Height )

{
 LPBITMAPINFOHEADER BIH = (LPBITMAPINFOHEADER) Ptr ;
 DWORD size = 0 ;

 BIH->biWidth = Width;
 BIH->biHeight = Height;

 /* round up line length to multiple of 4 */
 Width += (Width % 4 != 0) ? 4 - (Width % 4) : 0 ;

 switch (BIH -> biCompression)
  {    
   case BI_RGB :
        size = Width * Height * BIH -> biBitCount / 8 ;
        break ;
        
   case BI_YVU9 :
        size = Width * Height * 9 / 8 ;        /* total size 1.125 * Y pixels */
        break ;
        
   case BI_YUY2 :
   case BI_UYVY :
        size = Width * Height * 2 ;
        break ;
                 
   case BI_PSHU :
        size = Width * Height;
        break ;
   
   case BI_YV12 :
   case BI_PYUV :
   case BI_I420 :
        size = Width * Height * 3 / 2 ;        /* total size 1.5 * Y pixels */
        break ;
  }

 BIH -> biSizeImage = size;
}


void BIH_GetImageSize( LPVOID Ptr, LPLONG Width, LPLONG Height ) {
    LPBITMAPINFOHEADER BIH;
    DWORD size;
    LONG width;

    BIH = (LPBITMAPINFOHEADER)Ptr;
    *Width = BIH->biWidth;
    *Height = BIH->biHeight;

    return;
}


/* use below only after a SetType and SetImageSize() */
DWORD BIH_GetDataSize( LPVOID Ptr ) {
    LPBITMAPINFOHEADER BIH;
    BIH = (LPBITMAPINFOHEADER)Ptr;

    /* call SetImageSize() to ensure that the biSizeImage member has been calculated */
    BIH_SetImageSize( Ptr, BIH->biWidth, BIH->biHeight );

    return( BIH->biSizeImage );
}
