/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */



#define BI_YVU9 mmioFOURCC( 'Y', 'V', 'U', '9' )    /* Intel Raw YVU9 format    */
#define BI_YV12 mmioFOURCC( 'Y', 'V', '1', '2' )    /* YVU 12 Planar (4:2:0)    */
#define BI_YUY2 mmioFOURCC( 'Y', 'U', 'Y', '2' )    /* YUY2 4:2:2 format        */
#define BI_CYUV mmioFOURCC( 'c', 'y', 'u', 'v' )    /* Creative 4:2:2 format    */
#define BI_I420 mmioFOURCC( 'I', '4', '2', '0' )    /* intel 4:2:0              */
#define BI_IYUV mmioFOURCC( 'I', 'Y', 'U', 'V' )    /* same as I420             */
#define BI_UYVY mmioFOURCC( 'U', 'Y', 'V', 'Y' )    /* as YUY2, different order */
#define BI_PRAW mmioFOURCC( 'P', 'R', 'A', 'W' )    /* PPC raw image format     */

/* parallel port camera raw image capture formats */
#define BI_PYUV mmioFOURCC( 'P', 'Y', 'U', 'V' )    /* PPC YUV capture format   */
#define BI_PSHU mmioFOURCC( 'P', 'S', 'H', 'U' )    /* PPC Shuffle capture format*/



/* HEADER.C - module to handle BMPHEADERINFO structures */


void BIH_Init( LPVOID Ptr );

void BIH_SetType( LPVOID Ptr, WORD BitCount, DWORD Compression );
void BIH_GetType( LPVOID Ptr, LPWORD BitCount, LPDWORD Compression );

void BIH_SetImageSize( LPVOID Ptr, LONG Width, LONG Height );
void BIH_GetImageSize( LPVOID Ptr, LPLONG Width, LPLONG Height );

DWORD BIH_GetDataSize( LPVOID Ptr );    /* use only after a SetType and SetImageSize( void ) */



 
