/* Copyright 2000 STMicroelectronics. Free for use under the Gnu Public License */
#ifndef VFWDLG
#define VFWDLG

#define VIDEOCAPTURESETTINGS    VIDEO_EXTERNALIN
#define VIDEOFORMAT             VIDEO_IN
#define PARALLELPORTSETTING     3   

#define BRIGHTNESS_MIN          1
#define BRIGHTNESS_MAX          100
#define BRIGHTNESS_INITIAL      50
#define BRIGHTNESS_STEP         1
#define BRIGHTNESS_LSTEP        10

#define CONTRAST_MIN            1
#define CONTRAST_MAX            100
#define CONTRAST_INITIAL        50
#define CONTRAST_STEP           1
#define CONTRAST_LSTEP          10

#define COLOUR_MIN              1
#define COLOUR_MAX              100
#define COLOUR_INITIAL          50
#define COLOUR_STEP             1
#define COLOUR_LSTEP            10

/* these settings are used for the manual quality and the auto quality
   settings */
#define QUALITY_MIN             1
#define QUALITY_MAX             100
#define QUALITY_INITIAL         50
#define QUALITY_STEP            1
#define QUALITY_LSTEP           10

#define VIDCOMP_MIN              1
#define VIDCOMP_MAX              100
#define VIDCOMP_INITIAL          50
#define VIDCOMP_STEP             2
#define VIDCOMP_LSTEP            10 


#define TEMPDIFF                0
#define ZOOMVIDEO               0
#define DYNAMICDIFF             0


#define S320BY240               0
#define S240BY196               1
#define S176BY144               2
#define S160BY120               3
#define S128BY96                4
#define S112BY80                5
#define USEROPTION              6

#define IMAGEFORMAT             0
#define IMAGESIZE               S160BY120
#define IMAGEX                  160
#define IMAGEY                  120

typedef struct
{
    int Min;
    int Max;
    int Current;
    int Step;
    int Lstep;
} SliderParam;


#ifdef __cplusplus
extern "C"
{
#endif

void InitDialogParams(void);
void CloseDialog();


BOOL FAR PASCAL _loadds  VideoCaptureSettingsDialogProc (HWND hDlg, 
                                                         UINT message, 
                                                         WPARAM wParam, 
                                                         LPARAM lParam);
BOOL FAR PASCAL _loadds  VideoFormatDialogProc (HWND hDlg, UINT message, 
                                                WPARAM wParam, LPARAM lParam);
BOOL FAR PASCAL _loadds  ParallelPortSettingsDialogProc (HWND hDlg, 
                                                         UINT message, 
                                                         WPARAM wParam, 
                                                         LPARAM lParam);

int ProcessScroll(HWND hDlg, HWND hCtl, WPARAM wParam, LPARAM lParam,
                  WORD wIDEditBox, SliderParam* param);
ProcessEditBox (HWND hwnd, int edctl, int sbctl, SliderParam *sb) ;

void SetXYSize(HWND hDlg, int X, int Y );


BOOL FAR PASCAL _loadds DlgAboutProc (HWND hDlg, UINT message, WPARAM wParam,
                                      LPARAM lParam) ;
show_controls (HWND hwnd, BOOL show) ;
get_camera_info (HWND hwnd) ;
CheckFormat (HWND hdlg, int button) ;

#ifdef __cplusplus
}
#endif  

#endif

